type t = {
  year : int;
  month : int;
  day : int;
  category : string;
  subcategory : string;
  amount : float;
  account : string;
  payee : string;
  notes : string;
}

val create :
  year:float ->
  month:float ->
  day:float ->
  category:string ->
  ?subcategory:string ->
  amount:float ->
  account:string ->
  payee:string ->
  ?notes:string ->
  unit ->
  t

val mvt :
  float ->
  float ->
  float ->
  string ->
  string option ->
  float ->
  string ->
  string ->
  string option ->
  t

type predicate = t -> bool

val is_account_caisse : predicate

val is_account_courant : predicate

val any : predicate

val after : int -> int -> int -> predicate

val until : int -> int -> int -> predicate

val mvts : string -> t list
